// Deterministic daily traffic per channel; stacking shows total site visits
// split into its sources. Each channel is a mean-reverting walk around its
// own base so the composition shifts organically day to day.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function channel(seed, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025 GMT').getTime()
  var val = base
  for (var i = 0; i < 20; i++) {
    val += (rand() - 0.5) * spread
    val += (base - val) * 0.15
    series.push([ts, Math.max(2, Math.round(val))])
    ts += 86400000
  }
  return series
}

var options = {
  series: [
    {
      name: 'Organic Search',
      data: channel(11, 42, 14),
    },
    {
      name: 'Direct',
      data: channel(23, 26, 9),
    },
    {
      name: 'Social',
      data: channel(35, 15, 8),
    },
  ],
  chart: {
    type: 'area',
    height: 350,
    stacked: true,
    events: {
      selection: function (chart, e) {
        console.log(new Date(e.xaxis.min))
      },
    },
  },
  colors: ['#008FFB', '#00E396', '#FEB019'],
  dataLabels: {
    enabled: false,
  },
  stroke: {
    curve: 'monotoneCubic',
  },
  title: {
    text: 'Website Visits by Channel',
    align: 'left',
  },
  fill: {
    type: 'gradient',
    gradient: {
      opacityFrom: 0.6,
      opacityTo: 0.8,
    },
  },
  legend: {
    position: 'top',
    horizontalAlign: 'left',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return val + 'k'
      },
    },
  },
  xaxis: {
    type: 'datetime',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()
Stacked Area - JavaScript Area Charts | ApexCharts.js | ApexCharts.js

<template>
  <div>
    <div id="chart">
      <apexchart
        type="area"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Deterministic daily traffic per channel; stacking shows total site visits
// split into its sources. Each channel is a mean-reverting walk around its
// own base so the composition shifts organically day to day.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function channel(seed, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025 GMT').getTime()
  var val = base
  for (var i = 0; i < 20; i++) {
    val += (rand() - 0.5) * spread
    val += (base - val) * 0.15
    series.push([ts, Math.max(2, Math.round(val))])
    ts += 86400000
  }
  return series
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Organic Search',
          data: channel(11, 42, 14),
        },
        {
          name: 'Direct',
          data: channel(23, 26, 9),
        },
        {
          name: 'Social',
          data: channel(35, 15, 8),
        },
      ],
      chartOptions: {
        chart: {
          type: 'area',
          height: 350,
          stacked: true,
          events: {
            selection: function (chart, e) {
              console.log(new Date(e.xaxis.min))
            },
          },
        },
        colors: ['#008FFB', '#00E396', '#FEB019'],
        dataLabels: {
          enabled: false,
        },
        stroke: {
          curve: 'monotoneCubic',
        },
        title: {
          text: 'Website Visits by Channel',
          align: 'left',
        },
        fill: {
          type: 'gradient',
          gradient: {
            opacityFrom: 0.6,
            opacityTo: 0.8,
          },
        },
        legend: {
          position: 'top',
          horizontalAlign: 'left',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return val + 'k'
            },
          },
        },
        xaxis: {
          type: 'datetime',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Stacked Area in Angular

Using ApexCharts with Angular

This Stacked Area example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
          return function () {
            seed |= 0
            seed = (seed + 0x6d2b79f5) | 0
            var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private channel = (seed: any, base: any, spread: any): any => {
          var rand = this.mulberry32(seed)
          var series = []
          var ts = new Date('01 Jun 2025 GMT').getTime()
          var val = base
          for (var i = 0; i < 20; i++) {
            val += (rand() - 0.5) * spread
            val += (base - val) * 0.15
            series.push([ts, Math.max(2, Math.round(val))])
            ts += 86400000
          }
          return series
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Organic Search',
              data: this.channel(11, 42, 14),
            },
            {
              name: 'Direct',
              data: this.channel(23, 26, 9),
            },
            {
              name: 'Social',
              data: this.channel(35, 15, 8),
            },
          ],
          chart: {
            type: 'area',
            height: 350,
            stacked: true,
            events: {
              selection: (chart, e) => {
                console.log(new Date(e.xaxis.min))
              },
            },
          },
          colors: ['#008FFB', '#00E396', '#FEB019'],
          dataLabels: {
            enabled: false,
          },
          stroke: {
            curve: 'monotoneCubic',
          },
          title: {
            text: 'Website Visits by Channel',
            align: 'left',
          },
          fill: {
            type: 'gradient',
            gradient: {
              opacityFrom: 0.6,
              opacityTo: 0.8,
            },
          },
          legend: {
            position: 'top',
            horizontalAlign: 'left',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return val + 'k'
              },
            },
          },
          xaxis: {
            type: 'datetime',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Deterministic daily traffic per channel; stacking shows total site visits
// split into its sources. Each channel is a mean-reverting walk around its
// own base so the composition shifts organically day to day.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function channel(seed, base, spread) {
  var rand = mulberry32(seed)
  var series = []
  var ts = new Date('01 Jun 2025 GMT').getTime()
  var val = base
  for (var i = 0; i < 20; i++) {
    val += (rand() - 0.5) * spread
    val += (base - val) * 0.15
    series.push([ts, Math.max(2, Math.round(val))])
    ts += 86400000
  }
  return series
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Organic Search',
        data: channel(11, 42, 14),
      },
      {
        name: 'Direct',
        data: channel(23, 26, 9),
      },
      {
        name: 'Social',
        data: channel(35, 15, 8),
      },
    ],
    options: {
      chart: {
        type: 'area',
        height: 350,
        stacked: true,
        events: {
          selection: function (chart, e) {
            console.log(new Date(e.xaxis.min))
          },
        },
      },
      colors: ['#008FFB', '#00E396', '#FEB019'],
      dataLabels: {
        enabled: false,
      },
      stroke: {
        curve: 'monotoneCubic',
      },
      title: {
        text: 'Website Visits by Channel',
        align: 'left',
      },
      fill: {
        type: 'gradient',
        gradient: {
          opacityFrom: 0.6,
          opacityTo: 0.8,
        },
      },
      legend: {
        position: 'top',
        horizontalAlign: 'left',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return val + 'k'
          },
        },
      },
      xaxis: {
        type: 'datetime',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="area"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart